PrintIndex <- function(outputdir, ontology, nrgenes)
{
  ## Make directories first
  system(paste("mkdir ", outputdir, sep=""))
  for (i in seq(along=ontology)) {
    dname <- paste(outputdir, "/", ontology[i], sep="")
    system(paste("mkdir", dname))
    system(paste("mkdir ", dname, "/ind_terms", sep=""))
    system(paste("mkdir ", dname, "/images", sep=""))
    system(paste("mkdir ", dname, "/timepoints", sep=""))
  }

  dname <- paste(outputdir, "/allgenes", sep="")
  system(paste("mkdir", dname))
  system(paste("mkdir ", dname, "/images", sep=""))


  ## formatting startpage of html output
  fname <- paste(outputdir, "/start.html", sep="")
  cat("<html>
  <head>
    <title>start Gene Ontology in time</title>
    <style></style>
  </head>
  <body>
  I want to view Gene Ontology enrichment in time of GO type:
  <br><br>", file=fname)
  if ("MF" %in% ontology)
    cat("<a href=MF/indexMF.html>Molecular Function</a><br>",
        file=fname, append=TRUE)
  if ("BP" %in% ontology)
    cat("<a href=BP/indexBP.html>Biological Process</a> <br>",
        file=fname, append=TRUE)
  if ("CC" %in% ontology)
    cat("<a href=CC/indexCC.html>Cellular Component</a> <br>",
        file=fname, append=TRUE)
  cat("<br>This selection contains ", nrgenes, " genes.
 </body>
</html>", file=fname, append=TRUE)
}