"tree.category" <-
function(Enr, type, outputdir, ratios, metadata, timepoints, lpoints){
		cat(paste("making html for GO category ", type, "\n", sep=""))
		golist <- unique(unlist(Enr[[1]]))
		golist <- golist[!is.na(golist)]
				
# General picture of GO in time and summary page
		loc <- paste(outputdir, "/", type, "/", "images", "/", "general", type, ".png", sep="")
		loc2 <- paste(outputdir, "/", type, "/", "images", "/", "general", type, "2.png", sep="")
		loc3 <- paste(outputdir, "/", type, "/", "images", "/", "general", type, "3.png", sep="")

		fil <- paste(outputdir, "/", type, "/", "index", type, ".html", sep="")

		write("<html><center>", file=fil, append=FALSE)
		if (type=="MF"){
			write("<p><b>Summary of GO enrichment profiles for category Molecular Function</b></p>", file=fil, append=TRUE)
		}
		if (type=="BP"){
			write("<p><b>Summary of GO enrichment profiles for category Biological Process</b></p>", file=fil, append=TRUE)
		}
		if (type=="CC"){
			write("<p><b>Summary of GO enrichment profiles for category Cellular Component</b></p>", file=fil, append=TRUE)
		}
		write(paste("<img src=images/general", type, ".png>", sep=""), file=fil, append=TRUE)
		write(paste("<img src=images/general", type, "3.png>", sep=""), file=fil, append=TRUE)
		write("<br><br><br>", file=fil, append=TRUE)

# page per time point
		write("enrichment at individual timepoints: <br>", file=fil, append=TRUE)
		for (d in 1:length(timepoints)){
			tname <- paste("timepoint", as.character(timepoints[d]), sep="")
			write(paste("<a href=timepoints/", tname, "/", tname, ".html>", tname, "</a>", sep=""), file=fil, append=TRUE)
		}
		write("<br><br><br>", file=fil, append=TRUE)
		
# page per term
		write("Table of enriched processes", file=fil, append=TRUE)
		write("<center><table border=1>", file=fil, append=TRUE)
		write("<tr><td>proces</td><td># sign. points</td><td># genes in group</td><td>enriched timepoints</td></tr>", file=fil, append=TRUE)

#detremine order of golist based on # of sign timepoints
		oplot <- matrix(0, nrow=length(golist), ncol=length(timepoints))
		for (term in 1:length(golist)){
			for (t in 1:length(timepoints)){
				if(!is.na(Enr[[1]][[t]][1])){
					sel3 <- Enr[[1]][[t]] %in% golist[term]
					if (sum(sel3) > 0){
						oplot[term, t] <- length(Enr[[3]][[t]][sel3][[1]])
					}
				}
			}
		}
		oplot <- oplot > 0
		orderedterms <- order(apply(oplot, 1, sum), decreasing=TRUE)

		fplot <- matrix(0, nrow=length(golist), ncol=length(timepoints))
		for (term in orderedterms){
		gnames <- c()

# gather summary information for general plot
			for (t in 1:length(timepoints)){
				if(!is.na(Enr[[1]][[t]][1])){
					sel3 <- Enr[[1]][[t]] %in% golist[term]
					if (sum(sel3) > 0){
						fplot[term, t] <- length(Enr[[3]][[t]][sel3][[1]])
						gnames <- c(gnames, Enr[[3]][[t]][sel3][[1]])
					}
				}
			}

			namepng <- paste(outputdir, "/", type, "/images/", strsplit(golist[term], split=":")[[1]][2], ".png", sep="")
			namepng2 <- paste("../images/", strsplit(golist[term], split=":")[[1]][2], ".png", sep="")

			namepng3  <- paste(outputdir, "/", type, "/images/", strsplit(golist[term], split=":")[[1]][2], "2.png", sep="")
			namepng4  <- paste("../images/", strsplit(golist[term], split=":")[[1]][2], "2.png", sep="")

# collect all gene identifiers for specific GO term
			sel1 <- rep(FALSE, length(timepoints))
			for (i in 1:length(timepoints)){
				if (sum(Enr[[1]][[i]] %in% golist[term])>0){
					sel1[i] <- TRUE
				}
			}

			gnames <- as.character(na.omit(unique(unlist(gnames))))
			plotcl <- matrix(0, ncol=length(lpoints), nrow=length(gnames))

			for (w in 1:length(gnames)){
				plotcl[w,] <- unlist(ratios[ratios[,1] %in% gnames[w],-1])
			}

			ll <- getLL(gnames, data=metadata)
			namehtml <- paste(outputdir, "/", type, "/ind_terms/", as.character(strsplit(golist[term], split=":")[[1]][2]), ".html", sep="")
			namehtml2 <- paste("ind_terms/", as.character(strsplit(golist[term], split=":")[[1]][2]), ".html", sep="")
			write("<html><center>", file=namehtml, append=FALSE)
			write(paste("<p>The GO enrichment profile in time for the GO term <b>",  paste(getGOTerm(golist[term]), sep=""), "</b><p>", sep=""), file=namehtml, append=TRUE)
			img <- paste("<img src=", namepng2, ">", sep="")
			write(img, file=namehtml, append=TRUE)
			write("<br>", file=namehtml, append=TRUE)

			write("Clustered ratio profiles for this term<br>", file=namehtml, append=TRUE)
			img2 <- paste("<img src=", namepng4, ">", sep="")
			write(img2, file=namehtml, append=TRUE)
			write("<br>", file=namehtml, append=TRUE)

			write(paste("Table of enriched probes in category, the number of unique locuslink ids is ", length(unique(ll)), sep=""), file=namehtml, append=TRUE)
			write("<table border=1><tr><td>pr. set ident.</td><td>locus</td><td>Gene Name</td><td>Gene Symbol</td><td>cluster</td></tr>", file=namehtml, append=TRUE)

# determine clusters based on correlation
			if(length(gnames) > 0){
			
				if (length(gnames) > 5){
					cl <- kmeans(as.dist(1-cor(t(plotcl))), 5)$cluster
				}

				if (length(gnames) <= 5){
					if (length(gnames) > 2){
						cl <- kmeans(as.dist(1-cor(t(plotcl))), 2)$cluster
					}
					if (length(gnames) <= 2){
						cl <- c(1:length(gnames))
						cl[1:length(cl)] <- 1
					}
				}

#generate picture of GO enrichment profile
			png(file=namepng, width=300, height=300)
#			par(mfrow=c(1,1+max(cl)))
			plot(timepoints, fplot[term,], type="l", xlab="time", ylab="# probes in enriched category", main="enrichment profile for this term")
			abline(v=timepoints, lty=3, col="gray")
			dev.off()

			png(file=namepng3, width=200*max(cl), height=300)
			par(mfrow=c(1,max(cl)))
# generate picture of clusters of ratios in term

			for (i in 1:max(cl)){
				maxplot <- range(plotcl)
				plot(timepoints, plotcl[1,], type="n", xlab="time", ylab="log-ratio", ylim=maxplot, main=paste("cluster", as.character(i), sep=""))
				abline(v=timepoints, lty=3, col="gray")
				if (sum(cl==i) == 1){
					points(timepoints, plotcl[cl==i,], type="l", col=i)
					name <- lookUp(gnames[cl==i], metadata, "GENENAME")
					locus <- getLL(gnames[cl==i], data=metadata)
					symb <- lookUp(gnames[cl==i], metadata, "SYMBOL")
					write(paste("<tr><td><a href=../../allgenes/", gnames[cl==i], ".html>", gnames[cl==i], "</a></td><td>", locus, "</td><td>", name, "</td><td>", symb , "</td><td>", cl[cl==i],"</td></tr>", sep=""), file=namehtml, append=TRUE)	
				}
				if (sum(cl==i) > 1){
				for (z in 1:sum(cl==i)){
					points(timepoints, plotcl[cl==i,][z,], type="l", col=i)
					name <- lookUp(gnames[cl==i][z], metadata, "GENENAME")
					locus <- getLL(gnames[cl==i][z], data=metadata)
					symb <- lookUp(gnames[cl==i][z], metadata, "SYMBOL")
					write(paste("<tr><td><a href=../../allgenes/", gnames[cl==i][z], ".html>", gnames[cl==i][z], "</a></td><td>", locus, "</td><td>", name, "</td><td>", symb , "</td><td>", cl[cl==i][z],"</td></tr>", sep=""), file=namehtml, append=TRUE)	
				}
				}
			}
			dev.off()

			write("</table></p></html>", file=namehtml, append=TRUE)

			link <- paste("<tr><td><a href=", namehtml2, ">", getGOTerm(golist[term]), "</a></td><td>", sum(sel1), "</td><td>", length(unique(ll)),"</td><td>", paste(timepoints[sel1], collapse=" ") ,"</td></tr>", sep="")
			write(link, file=fil, append=TRUE)

			}
		}

		png(file=loc)		
		matplot(timepoints, t(fplot), type="l", xlab="Time", ylab="# of significant genes for term", main="profiles for all enriched terms")
		abline(v=timepoints, lty=3, col="gray")
		dev.off()

		png(file=loc3)
		matplot(timepoints, t(fplot/apply(fplot, 1, max)), type="l", xlab="Time", ylab="normalized profile per term", main="plot of normalized profiles")
		abline(v=timepoints, lty=3, col="gray")
		dev.off()

		write("</table></center>", file=fil, append=TRUE)
		write("</html>", file=fil, append=TRUE)
	}

