"tree.tpoint" <-
function(Enr, type, lpoints, outputdir, timepoints, ratios, m3, metadata){
	cat(paste("making html for each timepoint (GO category ", type, ")\n", sep=""))

	for (i in lpoints){
		tname <- paste("timepoint", as.character(timepoints[i]), sep="")
		
# make directory and table format of GO categories for each timepoint
		system(paste("mkdir ", outputdir, "/", type, "/timepoints/", tname, sep=""))
		system(paste("mkdir ", outputdir, "/", type, "/timepoints/", tname, "/ind_terms", sep=""))
		tfile <- paste(outputdir, "/", type, "/timepoints/", tname, "/", tname, ".html", sep="")
		write("<html><center>", file=tfile, append=FALSE)
		write(paste("<p><b>Table of Gene Ontology enrichment at timepoint ", as.character(i), "</p>", sep=""), file=tfile, append=TRUE)
		write("<br>", file=tfile, append=TRUE)
		write("<table border=1>", file=tfile, append=TRUE)
		write("<tr><td><b>proces</b></td><td><b>p-value of enrichment</b></td><td><b>genes in cat.</b></td><td><b>total on chip</b></td><td><b>ratio</b></td></tr>", file=tfile, append=TRUE)
		
# check for empty timepoints
		if(is.na(Enr[[1]][[i]][1])){
			cat("no GO categories for this timepoint\n")
			write("empty", file=tfile, append=TRUE)
		}

# Note GO categories and make links for each individual timepoint		
		else{
			for (w in 1:length(Enr[[1]][[i]])){
				goname <- strsplit(Enr[[1]][[i]][[w]], split=":")[[1]][2]
				write("<tr><td>", file=tfile, append=TRUE)
				write(paste("<a href=ind_terms/", goname, ".html>", paste(getGOTerm(Enr[[1]][[i]][w]), sep=""), "</a>",  sep=""), file=tfile, append=TRUE)
				write("</td><td>", file=tfile, append=TRUE)
				write(Enr[[2]][[i]][w], file=tfile, append=TRUE)
				write("</td>", file=tfile, append=TRUE)
				sel1 <- Enr[[1]][[i]] %in% Enr[[1]][[i]][[w]]
				ll <- unique(getLL(as.character(Enr[[3]][[i]][sel1][[1]]), data=metadata))

				write(paste("<td>", as.character(length(ll)), "</td>", sep=""), file=tfile, append=TRUE)
				write(paste("<td>", as.character(Enr[[4]][[i]][w]), "</td>", sep=""), file=tfile, append=TRUE)
				write(paste("<td>", as.character(round(length(ll)/Enr[[4]][[i]][w], digits=5)), "</td></tr>", sep="" ), file=tfile, append=TRUE)
				
				gotimeterm <- paste(outputdir, "/", type, "/timepoints/", tname, "/ind_terms/", goname, ".html", sep="")
				write("<html>", file=gotimeterm, append=FALSE)
				write("<table border=1>", file=gotimeterm, append=TRUE)
				write(paste("<p><b> Table of genes in the GO term: ", paste(getGOTerm(Enr[[1]][[i]][w]), sep="") ,"</b></p>", sep=""), file=gotimeterm, append=TRUE)
				write(paste("<p>The number of unique locuslink identifiers contributing to the enrichment of this term is ", as.character(length(ll)), "</p>", sep=""), file=gotimeterm, append=TRUE)
				write("<tr><td><b>probe set id.</b></td><td><b>locus</b></td><td><b>Gene Name</b></td><td><b>Symbol</b></td></tr>", file=gotimeterm, append=TRUE)
				probenames <- as.character(na.omit(unique(unlist(Enr[[3]][[i]][sel1]))))

				matje <- ratios[probenames,]
				matje <- abs(matje[, -1])
				vecmatje <- apply(matje, 1, max)
				volg2 <- order(vecmatje, decreasing=TRUE)
				probenames2 <- lookUp(c(probenames), metadata, "GENENAME")

				for (z in volg2){
					name <- probenames2[z]
					locus <- as.character(getLL(as.character(probenames[z]), data=metadata))
					symb <- lookUp(as.character(probenames[z]), metadata, "SYMBOL")
					write(paste("<tr><td><a href=../../../../allgenes/",
					as.character(probenames[z]), ".html>",
					as.character(probenames[z]), "</a></td><td>", locus, "</td><td>", name, "</td><td>", symb, "</td></tr>", sep=""), file=gotimeterm, append=TRUE)
				}

				write("</table></html>", file=gotimeterm, append=TRUE)
			}
		}
		write("</table></center></html>", file=tfile, append=TRUE)
	}
}

