\name{Go.enr}
\alias{Go.enr}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ function to generate results for GO enrichment calculations with GOHyperG }
\description{
  For all timepoints the GO enrichment is calculated for each of the three main GO categories: Molecular function, Biological process and Cellular component The resulting data are returned in a format which is used as input by the functions tree.category, tree.tpoint and tree.gene.
}
\usage{
Go.enr(Int, selmatrix, char_GO_type, metadata)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{Int}{  \code{Int} is a data frame containing the (log)ratio values, rows are genes and columns are timepoints, except the first column, this column should contain the gene identifiers which can be used with the metadata package for the experiment  }
  \item{selmatrix}{  \code{selmatrix} matrix with TRUE or FALSE values which indicate wether the ratio is significant at the specific timpoints for the concerning genes, rows are genes and columns are timepoints }
  \item{char_GO_type}{ \code{char_GO_type} character string containing the abbreviation of the category of GO which will be checked for enrichment, should be "MF", "BP" or "CC" }
  \item{metadata}{ \code{metadata} character string containing the name of the metadata package for the experiment }
}
\details{
   This function is used by the main GoTime function and is not to be called by the user. 
}
\value{
  A list with four elements is returned
  \item{comp1 }{list of timepoints with enriched GO terms at these timepoints}
  \item{comp2 }{significantly enriched GO terms (p < 0.01) pvalues}
  \item{comp3 }{list of timpeoints with the genes for each enriched GO term at this timepoint}
  \item{comp4 }{total nr of probes on the chip associated with this GO term}
}

\author{ J. de Haan }

\seealso{\code{\link{GoTime}}}

\keyword{ ts }
