"tree.gene" <-
function(Enr1, Enr2, Enr3, outputdir, ratios, pmat, metadata, timepoints){
	cat("making html for each individual gene\n")
	allgenes <- unique(c(unlist(Enr1[[3]]), unlist(Enr2[[3]]), unlist(Enr3[[3]])))

	allgenes <- allgenes[!is.null(allgenes)]
	allgenes <- allgenes[!is.na(allgenes)]
	loc_allgenes1 <- paste(outputdir, "/allgenes/", sep="")
	loc_allgenes2 <- paste(outputdir, "/allgenes/images/", sep="")

	for (q in 1:length(allgenes)){
		display <- strsplit(allgenes[q], "/")[[1]][1]
		genes1a <- paste(loc_allgenes1, display, ".html", sep="")

		write("<html>", file=genes1a, append=FALSE)
		write(paste("Information for the individual probeset ", as.character(allgenes[q]), "<br>", sep=""), file=genes1a, append=TRUE)
		write(getSYMBOL(allgenes[q], data=metadata), file=genes1a, append=TRUE)
		write("<br>", file=genes1a, append=TRUE)
		write(lookUp(allgenes[q], metadata, "GENENAME"), file=genes1a, append=TRUE)
		write("<br>", file=genes1a, append=TRUE)
		ident <- as.character(lookUp(allgenes[q], metadata, "ACCNUM"))
		write(paste("<a href=http://www.ncbi.nlm.nih.gov/entrez/query.fcgi?CMD=search&DB=Nucleotide&term=", ident, ">", ident, "</a>", sep=""), file=genes1a, append=TRUE) 

		write(paste("<br><img src=images/", display, ".png>", sep=""), file=genes1a, append=TRUE)
		write("</html>", file=genes1a, append=TRUE)
		
		png(paste(loc_allgenes2, display, ".png", sep=""), width=600, height=300)
		par(mfrow=c(1,2))
		plot(timepoints, ratios[(ratios[,1] %in% allgenes[q]),2:length(ratios[1,])], type="l", xlab="time", ylab="logratio")
		abline(v=timepoints, lty=3, col="gray")
		plot(timepoints, pmat[(ratios[,1] %in% allgenes[q]),], type="l", xlab="time", ylab="log pval for sign. of ratio")
		abline(v=timepoints, lty=3, col="gray")
		dev.off()
	}
}

