\name{tree.gene}
\alias{tree.gene}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ function to generate output for each probeset }
\description{
  For each individual gene(probeset), which is in an enriched category, a html page is generated. On this page the user can inspect the ratio data specific for this gene.
}
\usage{
tree.gene(Enr1, Enr2, Enr3, outputdir, ratios, pmat, metadata, timepoints)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{Enr1}{ \code{Enr} enrichment output from GOenr subfunction }
  \item{Enr2}{ \code{Enr} enrichment output from GOenr subfunction }
  \item{Enr3}{ \code{Enr} enrichment output from GOenr subfunction }
  \item{outputdir}{ \code{outputdir} the name of the directory which will be physically created in the working directory , after running the function this directory will contain the results as html and jpeg files }
  \item{ratios}{ \code{ratios} is a data frame containing the ratio values for the genes and timepoints, rows should be genes and columns should be timepoints, except for the first column which should contain the gene identifiers which can be used with the specific metadata package for the experiment }
  \item{pmat}{ \code{pmat} is a matrix of pvalues which were used to determine the significance of the ratios, columns are timepoints and rows are genes, the first column should be a timepoint }
  \item{metadata}{ \code{metadata} should contain a character string which names the metadata package associated with the experiment }
  \item{timepoints}{ \code{timepoints} is an optional vector which contains the real number of timeunits on for each timepoint }
}
\details{
   This function is for internal use by the GoTime function only and is not to be called by the user.
}
\value{
   No real value is returned by this function, html and jpeg files are generated as output
}

\author{ J. de Haan }

\seealso{ \code{\link{GoTime}} }

\keyword{ ts }
